/*
    QuickMSG
    Copyright (C) 2014  Jeroen Vreeken <jeroen@vreeken.net>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
#ifndef _INCLUDE_QUICKMSG_DB_H_
#define _INCLUDE_QUICKMSG_DB_H_

#include "contact.h"
#include "post.h"

struct quickmsg_db;

struct quickmsg_db *quickmsg_db_alloc(void);
void quickmsg_db_free(struct quickmsg_db *db);

struct contact_list *quickmsg_db_contact_get_all(
    struct quickmsg_db *db);
struct contact *quickmsg_db_contact_person_get_by_address(
    struct quickmsg_db *db, char *address);
struct contact *quickmsg_db_contact_get_by_id(
    struct quickmsg_db *db, int id);
struct contact *quickmsg_db_contact_group_get_by_address_and_group(
    struct quickmsg_db *db, char *address, int group);

int quickmsg_db_contact_insert(struct quickmsg_db *db, struct contact *c);
int quickmsg_db_contact_update(struct quickmsg_db *db, struct contact *c);
int quickmsg_db_contact_delete(struct quickmsg_db *db, struct contact *c);


int quickmsg_db_post_insert(struct quickmsg_db *db, struct post *p);

struct post_list *quickmsg_db_post_get_by_id(
    struct quickmsg_db *db, int id);

#endif /* _INCLUDE_QUICKMSG_DB_H_ */
